#include "CppUTest/TestHarness.h"

extern "C"
{
#include "ucos_ii.h"
#include "uCosIITestDouble-HandCrafted.h"
static int my_custom_OSSemPend_called;
void my_custom_OSSemPend(OS_EVENT *pevent, INT32U timeout, INT8U *perr)
{
	my_custom_OSSemPend_called++;
}

}

TEST_GROUP(uCosIITestDouble)
{
	OS_EVENT event;
	INT8U error;

	void setup()
	{
		error = -1;
		OSSemPend_Fake_Reset();
		my_custom_OSSemPend_called = 0;
	}
	void teardown()
	{

	}
};

TEST(uCosIITestDouble, OSSemPend_custom_ation)
{
	OSSemPend_fake.custom_action = my_custom_OSSemPend;
	OSSemPend(&event, 0, &error);
	LONGS_EQUAL(1, my_custom_OSSemPend_called);
}

TEST(uCosIITestDouble, OSSemPend)
{
	OSSemPend(&event, 0, &error);
}

TEST(uCosIITestDouble, OSSemPend_counts_calls)
{
	OSSemPend(&event, 0, &error);
	LONGS_EQUAL(1, OSSemPend_fake.call_count);
}

TEST(uCosIITestDouble, OSSemPend_remembers_parameters)
{
	OSSemPend(&event, 1000, &error);
	POINTERS_EQUAL(&event, OSSemPend_fake.event);
	LONGS_EQUAL(1000, OSSemPend_fake.timeout);
	POINTERS_EQUAL(&error, OSSemPend_fake.error);
}

TEST(uCosIITestDouble, OSSemPend_returns_what_i_want)
{
	OSSemPend_fake.return_this = 4;
	OSSemPend(&event, 0, &error);
	LONGS_EQUAL(4, error);
}


