#include "CppUTest/TestHarness.h"

extern "C"
{
	#include "uCosIITestDouble.h"
}

static int myFakePendCalled;
void FakeOSSemPend(OS_EVENT *pevent,INT32U timeout, INT8U *perr)
{
	myFakePendCalled = 1;
}

static int myFakePostCalled;
INT8U FakeOSSemPost (OS_EVENT *pevent)
{
	myFakePostCalled = 1;
}


TEST_GROUP(OSSemTestDouble)
{
	OS_EVENT * os_event;
	INT8U result;

    void setup()
    {
    		OSSemCreate_TestDoubleSetup(FakeOSSemPend, FakeOSSemPost);
    		myFakePendCalled = 0;
    		myFakePostCalled = 0;
    		os_event = OSSemCreate(1);
    }

    void teardown()
    {
    		OSSemDel(os_event, 0, 0);
    		LONGS_EQUAL(1, OSSemDel_GetCallCount());
		OSSemCreate_TestDoubleTearDown();
    }
};

TEST(OSSemTestDouble, create_and_destroy_report_call_counts)
{
	LONGS_EQUAL(1, OSSemCreate_GetCallCount());
	LONGS_EQUAL(0, OSSemDel_GetCallCount());
	CHECK_FALSE(myFakePostCalled);
	CHECK_FALSE(myFakePendCalled);
}

DECLARE__FAKE_VOID_FUNC(OSSemPend, OS_EVENT*, INT32U, INT8U*);
TEST(fff, create_and_destroy_report_call_counts)
{
	OS_EVENT os_event;
	INT8U error = 0;

	OSSemPend(&os_event, 0, &error);
	LONGS_EQUAL(1, OSSemPend_call_count);
	POINTERS_EQUAL(&os_event, OSSemPend_arg0_val);
	LONGS_EQUAL(0, OSSemPend_arg1_val);
	LONGS_EQUAL(0, OSSemPend_fake.arg1_val);
	LONGS_EQUAL(0, *OSSemPend_arg2_val);

}




