#include "MessageProcessor.h"
#include "SerialInterrupt.h"
#include "ucos_ii.h"
#include "common.h"

static OS_EVENT * int_sync;

void MessageProcessor_Create(void)
{
	int_sync = OSSemCreate(1);
}

void MessageProcessor_Destroy(void)
{
	INT8U error;
	OSSemDel(int_sync, 0, &error);
}

int MessageProcessor_WaitForMessage(char * buffer, size_t length)
{
	INT8U error = 0;
	SerialInterrupt_WaitingFor(buffer, length, int_sync);
	OSSemPend(int_sync, 1000, &error);
	if (error == OS_ERR_NONE)
		return TRUE;
	buffer[0] = 0;
	return FALSE;
}

